diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/test/mpi-example-comm-2-init.reflog ns-3.33/src/mpi/test/mpi-example-comm-2-init.reflog
--- ns-3.32/src/mpi/test/mpi-example-comm-2-init.reflog	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/mpi/test/mpi-example-comm-2-init.reflog	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1,14 @@
+TEST : 00000 : 
+TEST : 00001 : 
+TEST : 00002 : Configuration:
+TEST : 00003 : Routing:           nix-vector
+TEST : 00004 : Synchronization:   granted time window (YAWNS)
+TEST : 00005 : MPI_Init called:   explicitly by this program
+TEST : 00006 : ns-3 Communicator: MPI_COMM_WORLD (2 ranks)
+TEST : 00007 : PCAP tracing:      not enabled
+TEST : 00008 : 
+TEST : 00009 : Rank assignments:
+TEST : 00010 : ns-3 rank:  in MPI_COMM_WORLD: 0:2, in splitComm: 0:2
+TEST : 00011 : 
+TEST : 00012 : 
+TEST : 00013 : PASSED
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/test/mpi-example-comm-2.reflog ns-3.33/src/mpi/test/mpi-example-comm-2.reflog
--- ns-3.32/src/mpi/test/mpi-example-comm-2.reflog	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/mpi/test/mpi-example-comm-2.reflog	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1,14 @@
+TEST : 00000 : 
+TEST : 00001 : 
+TEST : 00002 : Configuration:
+TEST : 00003 : Routing:           nix-vector
+TEST : 00004 : Synchronization:   granted time window (YAWNS)
+TEST : 00005 : MPI_Init called:   implicitly by ns3::MpiInterface::Enable()
+TEST : 00006 : ns-3 Communicator: MPI_COMM_WORLD (2 ranks)
+TEST : 00007 : PCAP tracing:      not enabled
+TEST : 00008 : 
+TEST : 00009 : Rank assignments:
+TEST : 00010 : ns-3 rank:  in MPI_COMM_WORLD: 0:2, in splitComm: 0:2
+TEST : 00011 : 
+TEST : 00012 : 
+TEST : 00013 : PASSED
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/test/mpi-example-comm-3-init.reflog ns-3.33/src/mpi/test/mpi-example-comm-3-init.reflog
--- ns-3.32/src/mpi/test/mpi-example-comm-3-init.reflog	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/mpi/test/mpi-example-comm-3-init.reflog	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1,12 @@
+TEST : 00000 : 
+TEST : 00001 : 
+TEST : 00002 : Configuration:
+TEST : 00003 : Routing:           nix-vector
+TEST : 00004 : Synchronization:   granted time window (YAWNS)
+TEST : 00005 : MPI_Init called:   explicitly by this program
+TEST : 00006 : ns-3 Communicator: Split [1-2] (out of 3 ranks) from MPI_COMM_WORLD
+TEST : 00007 : PCAP tracing:      not enabled
+TEST : 00008 : 
+TEST : 00009 : Rank assignments:
+TEST : 00010 : Other rank: in MPI_COMM_WORLD: 0:3, in splitComm: 0:1
+TEST : 00011 : 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/test/mpi-example-empty-2-nullmsg.reflog ns-3.33/src/mpi/test/mpi-example-empty-2-nullmsg.reflog
--- ns-3.32/src/mpi/test/mpi-example-empty-2-nullmsg.reflog	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/mpi/test/mpi-example-empty-2-nullmsg.reflog	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1 @@
+TEST : 00000 : PASSED
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/test/mpi-example-empty-2.reflog ns-3.33/src/mpi/test/mpi-example-empty-2.reflog
--- ns-3.32/src/mpi/test/mpi-example-empty-2.reflog	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/mpi/test/mpi-example-empty-2.reflog	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1 @@
+TEST : 00000 : PASSED
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/test/mpi-example-empty-3-nullmsg.reflog ns-3.33/src/mpi/test/mpi-example-empty-3-nullmsg.reflog
--- ns-3.32/src/mpi/test/mpi-example-empty-3-nullmsg.reflog	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/mpi/test/mpi-example-empty-3-nullmsg.reflog	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1 @@
+TEST : 00000 : PASSED
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/test/mpi-example-empty-3.reflog ns-3.33/src/mpi/test/mpi-example-empty-3.reflog
--- ns-3.32/src/mpi/test/mpi-example-empty-3.reflog	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/mpi/test/mpi-example-empty-3.reflog	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1 @@
+TEST : 00000 : PASSED
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/test/mpi-example-nms-2.reflog ns-3.33/src/mpi/test/mpi-example-nms-2.reflog
--- ns-3.32/src/mpi/test/mpi-example-nms-2.reflog	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/mpi/test/mpi-example-nms-2.reflog	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1,20 @@
+TEST : 00000 :  ==== DARPA NMS CAMPUS NETWORK SIMULATION ====
+TEST : 00001 : Number of CNs: 2, LAN nodes: 10
+TEST : 00002 : Creating Campus Network 0:
+TEST : 00003 :   SubNet [ 0 1 2 3 ]
+TEST : 00004 :   Connecting Subnets...
+TEST : 00005 :   Assigning IP addresses...
+TEST : 00006 : Creating Campus Network 1:
+TEST : 00007 :   SubNet [ 0 1 2 3 ]
+TEST : 00008 :   Connecting Subnets...
+TEST : 00009 :   Assigning IP addresses...
+TEST : 00010 : Forming Ring Topology...
+TEST : 00011 : Creating UDP Traffic Flows:
+TEST : 00012 :   Campus Network 0 Flows [ Net2 Net3 ]
+TEST : 00013 :   Campus Network 1 Flows [ Net2 Net3 ]
+TEST : 00014 : Created 308 nodes.
+TEST : 00015 : Using Nix-vectors...
+TEST : 00016 : Running simulator...
+TEST : 00017 : Simulator finished.
+TEST : 00018 : PASSED
+TEST : 00019 : -----
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/test/mpi-example-simple-2-nullmsg.reflog ns-3.33/src/mpi/test/mpi-example-simple-2-nullmsg.reflog
--- ns-3.32/src/mpi/test/mpi-example-simple-2-nullmsg.reflog	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/mpi/test/mpi-example-simple-2-nullmsg.reflog	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1 @@
+TEST : 00000 : PASSED
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/test/mpi-example-simple-2.reflog ns-3.33/src/mpi/test/mpi-example-simple-2.reflog
--- ns-3.32/src/mpi/test/mpi-example-simple-2.reflog	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/mpi/test/mpi-example-simple-2.reflog	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1 @@
+TEST : 00000 : PASSED
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/test/mpi-example-third-2.reflog ns-3.33/src/mpi/test/mpi-example-third-2.reflog
--- ns-3.32/src/mpi/test/mpi-example-third-2.reflog	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/mpi/test/mpi-example-third-2.reflog	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1 @@
+TEST : 00000 : PASSED
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/test/mpi-test-suite.cc ns-3.33/src/mpi/test/mpi-test-suite.cc
--- ns-3.32/src/mpi/test/mpi-test-suite.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/mpi/test/mpi-test-suite.cc	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1,134 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018 Lawrence Livermore National Laboratory
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Peter D. Barnes, Jr. <pdbarnes@llnl.gov>
+ */
+
+#include "ns3/example-as-test.h"
+
+#include <sstream>
+
+using namespace ns3;
+
+/**
+ * This version of ns3::ExampleTestCase is specialized for MPI
+ * by accepting the number of ranks as a parameter,
+ * then building a `--command-template` string which
+ * invokes `mpiexec` correctly to execute MPI examples.
+ */
+class MpiTestCase : public ExampleAsTestCase
+{
+public:
+  /**
+   * \copydoc ns3::ExampleAsTestCase::ExampleAsTestCase
+   *
+   * \param [in] ranks The number of ranks to use
+   */
+  MpiTestCase (const std::string name,
+               const std::string program,
+               const std::string dataDir,
+               const int ranks,
+               const std::string args = "");
+
+  /** Destructor */
+  virtual ~MpiTestCase (void) {};
+
+  /**
+   * Produce the `--command-template` argument which will invoke
+   * `mpiexec` with the requested number of ranks.
+   *
+   * \returns The `--command-template` string.
+   */
+  std::string GetCommandTemplate (void) const;
+
+  /**
+   * Sort the output from parallel execution.
+   * stdout from multiple ranks is not ordered.
+   *
+   * \returns Sort command
+   */
+  std::string
+  GetPostProcessingCommand (void) const;
+  
+private:
+  /** The number of ranks. */
+  int m_ranks;            
+};
+
+MpiTestCase::MpiTestCase (const std::string name,
+                          const std::string program,
+                          const std::string dataDir,
+                          const int ranks,
+                          const std::string args /* = "" */)
+  : ExampleAsTestCase (name, program, dataDir, args),
+    m_ranks (ranks)
+{
+}
+
+std::string
+MpiTestCase::GetCommandTemplate (void) const
+{
+  std::stringstream ss;
+  ss << "mpiexec -n " << m_ranks  << " %s --test " << m_args;
+  return ss.str ();
+}
+
+std::string
+MpiTestCase::GetPostProcessingCommand (void) const
+{
+  std::string command ("| grep TEST | sort ");
+  return command;
+}
+
+/** MPI specialization of ns3::ExampleTestSuite. */
+class MpiTestSuite : public TestSuite
+{
+public:
+  /**
+   * \copydoc MpiTestCase::MpiTestCase
+   *
+   * \param [in] duration Amount of time this test takes to execute
+   *             (defaults to QUICK).
+   */
+  MpiTestSuite (const std::string name,
+                const std::string program,
+                const std::string dataDir,
+                const int ranks,
+                const std::string args = "",
+                    const TestDuration duration=QUICK)
+    : TestSuite (name, EXAMPLE)
+  {
+    AddTestCase (new MpiTestCase (name, program, dataDir, ranks, args), duration);
+  }
+
+};  // class MpiTestSuite
+
+/* Tests using SimpleDistributedSimulatorImpl */
+static MpiTestSuite g_mpiNms2      ("mpi-example-nms-2",       "nms-p2p-nix-distributed", NS_TEST_SOURCEDIR, 2);
+static MpiTestSuite g_mpiComm2     ("mpi-example-comm-2",      "simple-distributed-mpi-comm", NS_TEST_SOURCEDIR, 2);
+static MpiTestSuite g_mpiComm2comm ("mpi-example-comm-2-init", "simple-distributed-mpi-comm", NS_TEST_SOURCEDIR, 2, "--init");
+static MpiTestSuite g_mpiComm3comm ("mpi-example-comm-3-init", "simple-distributed-mpi-comm", NS_TEST_SOURCEDIR, 3, "--init");
+static MpiTestSuite g_mpiEmpty2    ("mpi-example-empty-2",     "simple-distributed-empty-node", NS_TEST_SOURCEDIR, 2);
+static MpiTestSuite g_mpiEmpty3    ("mpi-example-empty-3",     "simple-distributed-empty-node", NS_TEST_SOURCEDIR, 3);
+static MpiTestSuite g_mpiSimple2   ("mpi-example-simple-2",    "simple-distributed", NS_TEST_SOURCEDIR, 2);
+static MpiTestSuite g_mpiThird2    ("mpi-example-third-2",     "third-distributed", NS_TEST_SOURCEDIR, 2);
+
+/* Tests using NullMessageSimulatorImpl */
+static MpiTestSuite g_mpiSimple2NullMsg ("mpi-example-simple-2-nullmsg",    "simple-distributed", NS_TEST_SOURCEDIR, 2, "--nullmsg");
+static MpiTestSuite g_mpiEmpty2NullMsg  ("mpi-example-empty-2-nullmsg",     "simple-distributed-empty-node", NS_TEST_SOURCEDIR, 2, "-nullmsg");
+static MpiTestSuite g_mpiEmpty3NullMsg  ("mpi-example-empty-3-nullmsg",     "simple-distributed-empty-node", NS_TEST_SOURCEDIR, 3, "-nullmsg");
+
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/wscript ns-3.33/src/mpi/wscript
--- ns-3.32/src/mpi/wscript	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/wscript	2021-01-09 10:19:22.000000000 -0800
@@ -54,12 +54,19 @@
         'model/mpi-interface.cc', 
         ]
 
+    # MPI tests are based on examples that are run as tests, only test when examples are built.
+    if bld.env['ENABLE_EXAMPLES']:
+        module_test = bld.create_ns3_module_test_library('mpi')
+        module_test.source = [
+            'test/mpi-test-suite.cc',
+        ]
+
     headers = bld(features='ns3header')
     headers.module = 'mpi'
     headers.source = [
         'model/mpi-receiver.h',
         'model/mpi-interface.h',
-        'model/parallel-communication-interface.h', 
+        'model/parallel-communication-interface.h',
         ]
 
     if bld.env['ENABLE_MPI']:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/netanim/bindings/callbacks_list.py ns-3.33/src/netanim/bindings/callbacks_list.py
--- ns-3.32/src/netanim/bindings/callbacks_list.py	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/netanim/bindings/callbacks_list.py	2021-01-09 10:19:22.000000000 -0800
@@ -33,11 +33,12 @@
     ['void', 'ns3::Ptr<const ns3::Packet>', 'double', 'ns3::WifiMode', 'ns3::WifiPreamble', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::WifiMode', 'ns3::WifiPreamble', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::WifiPsdu>', 'ns3::WifiTxVector', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'std::unordered_map<unsigned short, ns3::Ptr<const ns3::WifiPsdu>, std::hash<unsigned short>, std::equal_to<unsigned short>, std::allocator<std::pair<const unsigned short, ns3::Ptr<const ns3::WifiPsdu> > > >', 'ns3::WifiTxVector', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'std::map<std::pair<unsigned int, unsigned int>, double, std::less<std::pair<unsigned int, unsigned int> >, std::allocator<std::pair<const std::pair<unsigned int, unsigned int>, double> > >', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::WifiTxVector', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::WifiPhyRxfailureReason', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'ns3::WifiTxVector', 'ns3::MpduInfo', 'ns3::SignalNoiseDbm', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'ns3::WifiTxVector', 'ns3::MpduInfo', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'ns3::WifiTxVector', 'ns3::MpduInfo', 'ns3::SignalNoiseDbm', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'ns3::WifiTxVector', 'ns3::MpduInfo', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::HePreambleParameters', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::Socket>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['bool', 'ns3::Ptr<ns3::Socket>', 'const ns3::Address &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
